/***********************************************************************
|  Genealogy management system
|  Copyright (C) Karl Dahlke 1994
|  This software may be freely used by anyone for any personal,
|  non-profit purpose, and may be freely distributed to others.
|*********************************************************************/

/* structs.ec: structures for geniology database.
 * These structures are completely analogous to tables in SQL,
 * since we will probably convert this whole mess to an SQL DBMS someday.
 * Use 0 for a null link.
 * All structures should be a multiple of 4 bytes in size,
 * with shorts and longs properly alined. */

${
#include <setjmp.h>

#define CURRENT_EMAIL "eklhad@sis.rpslmc.edu"

extern jmp_buf main_menu;
extern char line[], qkcat[];
extern date lowdate, highdate;
extern char datemsg[], temp_textfile[], temp_10file[];
extern char fld1[], fld2[], fld3[];
extern char cur_fname[], cur_mname[], cur_lname[];
extern char cur_birthplace[];
extern struct person cur_prs;
extern long cur_prs_rowid, birth_rowid;
extern char *textfilename(), *qkdesc(), *gng_nextfile();
extern long edfile(), foldin_text(), extract_file();
extern long getdad(), getmom();
extern long searchfor(), moddate(), this_dbid;
extern short this_version;
extern date getdate();
extern struct name *getname();
extern char *shortnote();

#define SPREADMAX 50
struct SPREADDATA {
long rownum, prsid, order;
char adopt;
char filler[3];
};
extern struct SPREADDATA spreaddata[];
extern int spreadnum;
$}

node serial person {
/* implicit serial number */
date birth, death;
char sex;
char txtc1;
short txtcnt;
};

node serial name {
long prsid; /* link to person */
date start, end; /* duration over which this name is valid */
long hashval; /* for name search */
char birth; /* name at birth */
char nickname; /* just a nickname */
char search; /* searchable name */
#define NAMELEN 49
char fullname[NAMELEN];
}:
index prsid 2 1: bounded index hashval 1 500;

node serial address {
long prsid; /* link to a person */
date start, end;
#define AFREELEN 40
char free[AFREELEN];
}:
index prsid 1 1;

node serial prslink {
long prs1, prs2;
date start, end;
char linktype; /* H|M|F */
unsigned char adopt:1;
unsigned char from1:1;
unsigned char from2:1;
short filler;
}:
index prs1 7 1: index prs2 7 2;

node serial textent {
long prsid;
date when;
long offset;
long source;
char etype; /* type of entry */
char filler[3];
};

node serial qknote {
long prsid;
char ntype;
#define QKNOTE_LEN 79
char note[QKNOTE_LEN];
#define QKNOTE_CAT 7 /* number of categories */
}:
index prsid 3 1;

global:
eprint_exit exit;

/* global variables, corresponding to the externs above */
${
short this_version = 2;
long this_dbid;
jmp_buf main_menu;
char line[256];
char qkcat[] = "bdmeora";
char temp_textfile[20] = "gngtext";
char temp_10file[20] = "gng10tx";
date lowdate, highdate;
char datemsg[150];
char fld1[NAMELEN], fld2[NAMELEN], fld3[NAMELEN];
char cur_fname[NAMELEN], cur_mname[NAMELEN], cur_lname[NAMELEN];
char cur_birthplace[QKNOTE_LEN];
struct person cur_prs;
long cur_prs_rowid, birth_rowid;
struct SPREADDATA spreaddata[SPREADMAX];
int spreadnum;
$}
