#include "../ecl/eclib.h"

#include <setjmp.h>

#define EXP_VARNUM 20
#define EXP_OP 21
#define EXP_BUILTIN 22
#define EXPLEN 30 /* largest expression */
#define ARRAYLEN 20 /* length of array of answers */
#define STACKSIZE 400
#define ARRAYBIT 0x1000 /* bit indicating array */
#define is_array(b) ((b)->stringmod&0x10)
#define blockname(b) code_to_string((b)->name)

#define BLK_QUES 1 /* block is a question */
#define BLK_DECL 2 /* block is a declaration */
#define BLK_IF 3 /* block is an if jump */
#define BLK_WHILE 4 /* block is an while loop */
#define BLK_ASG 5 /* variable assignment */
#define BLK_ARPOP 6 /* pop array */
#define BLK_CONT 7 /* continue */
#define BLK_BREAK 8 /* break */
#define BLK_ECHO 9
#define BLK_LA 10 /* loop over array */
#define BLK_ARCLEAR 11
#define BLK_ENDARG 12
#define BLK_RET 13
#define BLK_CALL 14
#define BLK_PARMSET 15
#define BLK_ENDFN 16

#define TYPE_MONEY 1
#define TYPE_INT 2
#define TYPE_FN 3
#define TYPE_STRING 4
#define TYPE_BOOL 5
#define TYPE_DATE 6

extern jmp_buf actjmp;
extern int icfdebug, inbatch;
extern struct serial_inmem blist;
extern char streamuse[100], *tfname();
extern FILE *formfile, *ansfile;
extern char *ansfilename;
extern struct block *bnum_to_block(), *bname_to_block();

struct expstr {
long *e;
int size_e;
};


extern char opt_d;
extern char opt_v;
extern char opt_f;
extern char *opt_l;
extern char *opt_w;
struct list_domain_member {
struct domain_member *head, *tail;
struct domain_member *head_1, *tail_1;
short n_nodes;
};

struct domain_member {
struct domain_member *next, *last;
struct domain_member *next_1, *last_1;
 /* a domain element */
short elnum; /* element number */
#define cmp_domain_member(s,t) (s->elnum-t->elnum)
str_code elsym; /* element symbol */
#define cmp_domain_member_1(s,t) ci_strncmp(code_to_string(s->elsym), code_to_string(t->elsym), 0)

};

#define STRUCT_domain_member 0
#define get_domain_member() (struct domain_member *) ZC_get_struct(0)
#define copy_domain_member(s)  (struct domain_member *) ZC_copy_struct((char *)(s), 0)
#define free_domain_member(s)  ZC_free_struct((char *)(s), 0)
#define zap_list_domain_member(t) ZC_zap_list_gen((t), 0)
#define copy_list_domain_member(s,t) ZC_copy_list_gen((char *)(s), (char *)(t), 0)

#define RANGE_LOOP_domain_member(t, start, end) \
{ struct domain_member *ZC_var1; \
for((t) = (start); (t) != (end); (t) = ZC_var1) { \
ZC_var1 = (t)->next;
#define LOOP_domain_member(list, t) RANGE_LOOP_domain_member((t), (list)->head, 0)
#define BACK_RANGE_LOOP_domain_member(t, start, end) \
{ struct domain_member *ZC_var1; \
for((t) = (start); (t) != (end); (t) = ZC_var1) { \
ZC_var1 = (t)->last;
#define BACK_LOOP_domain_member(list, t) BACK_RANGE_LOOP_domain_member((t), (list)->tail, 0)
#define END_LOOP_domain_member } }
extern struct domain_member *find_domain_member(),
	*find_extract_domain_member();
#define RANGE_LOOP_domain_member_1(t, start, end) \
{ struct domain_member *ZC_var1; \
for((t) = (start); (t) != (end); (t) = ZC_var1) { \
ZC_var1 = (t)->next_1;
#define LOOP_domain_member_1(list, t) RANGE_LOOP_domain_member_1((t), (list)->head_1, 0)
#define BACK_RANGE_LOOP_domain_member_1(t, start, end) \
{ struct domain_member *ZC_var1; \
for((t) = (start); (t) != (end); (t) = ZC_var1) { \
ZC_var1 = (t)->last_1;
#define BACK_LOOP_domain_member_1(list, t) BACK_RANGE_LOOP_domain_member_1((t), (list)->tail_1, 0)
#define END_LOOP_domain_member_1 } }
extern struct domain_member *find_domain_member_1(),
	*find_extract_domain_member_1();
#define extract_domain_member(list, t) ZC_extract((list), (t), STRUCT_domain_member, 0)
#define extract_free_domain_member(list, t) ZC_extract((list), (t), STRUCT_domain_member, 1)
extern struct domain_member *ZC_insert_domain_member();
#define insert_domain_member(list, t) ZC_insert_domain_member((list), (t), 0)
#define copy_insert_domain_member(list, t) ZC_insert_domain_member((list), (t), 1)
struct list_domain {
struct domain *head, *tail;
struct domain *head_1, *tail_1;
short n_nodes;
};

struct domain {
struct domain *next, *last;
struct domain *next_1, *last_1;

struct list_domain_member members;
short dnum;
#define cmp_domain(s,t) (s->dnum-t->dnum)
str_code name;
#define cmp_domain_1(s,t) ((int)s->name-(int)t->name)
str_code helpmsg;

};

#define STRUCT_domain 1
#define get_domain() (struct domain *) ZC_get_struct(1)
#define copy_domain(s)  (struct domain *) ZC_copy_struct((char *)(s), 1)
#define free_domain(s)  ZC_free_struct((char *)(s), 1)
#define zap_list_domain(t) ZC_zap_list_gen((t), 1)
#define copy_list_domain(s,t) ZC_copy_list_gen((char *)(s), (char *)(t), 1)

#define RANGE_LOOP_domain(t, start, end) \
{ struct domain *ZC_var1; \
for((t) = (start); (t) != (end); (t) = ZC_var1) { \
ZC_var1 = (t)->next;
#define LOOP_domain(list, t) RANGE_LOOP_domain((t), (list)->head, 0)
#define BACK_RANGE_LOOP_domain(t, start, end) \
{ struct domain *ZC_var1; \
for((t) = (start); (t) != (end); (t) = ZC_var1) { \
ZC_var1 = (t)->last;
#define BACK_LOOP_domain(list, t) BACK_RANGE_LOOP_domain((t), (list)->tail, 0)
#define END_LOOP_domain } }
extern struct domain *find_domain(),
	*find_extract_domain();
#define RANGE_LOOP_domain_1(t, start, end) \
{ struct domain *ZC_var1; \
for((t) = (start); (t) != (end); (t) = ZC_var1) { \
ZC_var1 = (t)->next_1;
#define LOOP_domain_1(list, t) RANGE_LOOP_domain_1((t), (list)->head_1, 0)
#define BACK_RANGE_LOOP_domain_1(t, start, end) \
{ struct domain *ZC_var1; \
for((t) = (start); (t) != (end); (t) = ZC_var1) { \
ZC_var1 = (t)->last_1;
#define BACK_LOOP_domain_1(list, t) BACK_RANGE_LOOP_domain_1((t), (list)->tail_1, 0)
#define END_LOOP_domain_1 } }
extern struct domain *find_domain_1(),
	*find_extract_domain_1();
#define extract_domain(list, t) ZC_extract((list), (t), STRUCT_domain, 0)
#define extract_free_domain(list, t) ZC_extract((list), (t), STRUCT_domain, 1)
extern struct domain *ZC_insert_domain();
#define insert_domain(list, t) ZC_insert_domain((list), (t), 0)
#define copy_insert_domain(list, t) ZC_insert_domain((list), (t), 1)
extern struct list_domain  domains;
struct block {

short blktype; /* question, declaration, if test, etc */
short bnum;
str_code name;
char vartype, stringmod;
long ask; /* question to be asked */
long nextask; /* second question to be asked */
long explain; /* explanation, if you don't understand the question */
long answer; /* answer to the question*/
long *formula; /* if formula then jump to line 30 etc */
short fmsize; /* length of formula */
/* the above array of longs is also used to hold a sequence of
 * answers, when the variable is declared as an array. */
short gotonum; /* if formula goto gotonum */
char notnull; /* has question been answered */
char fromstack;
short filler;

};

#define STRUCT_block 2
#define select_block(id) (struct block *) ZC_select_row_file(2, (long)(id), (char*)0)
#define select_copy_block(id, buf) (struct block *) ZC_select_row_file(2, (long)(id), (buf))
#define select_mem_block(l, id) (struct block *) ZC_select_row_mem((l), (long)(id), (char*)0)
#define select_copy_mem_block(l, id, buf) (struct block *) ZC_select_row_mem((l), (long)(id), (buf))
#define delete_block(id) ZC_delete_row_file(2, (long)(id))
#define delete_mem_block(l, id) ZC_delete_row_mem((l), (long)(id))
#define insupd_block(id, buf)  ZC_insupd_row_file(2, (long)(id), (buf))
#define insupd_mem_block(l, id, buf)  ZC_insupd_row_mem((l), (long)(id), (buf))

#define LOOP_block(c, t, copy) \
start_scan(c, (struct serial_inmem*)0, STRUCT_block, (char *)(copy), 0L, (char*)0); \
while(t = (struct block *)next_scan(c)) {
#define MEM_LOOP_block(c, t, x, copy) \
start_scan(c, (struct serial_inmem*)(x), STRUCT_block, (char *)(copy), 0L, (char*)0); \
while(t = (struct block *)next_scan(c)) {
#define IDX_LOOP_block(c, t, copy, lowkey, idxname) \
start_scan(c, (struct serial_inmem*)0, STRUCT_block, (char *)(copy), (long)(lowkey), (char*)(idxname)); \
while(t = (struct block *)next_scan(c)) {
#define END_LOOP_block(c) } end_scan(c);
#define STRING_LENGTH 200
#define WORD_LENGTH 40
extern char *ZC_t_names[];
extern char ZC_parsedeb;
extern char *ZC_tok_strings[];
#define TOK_ASG 1
#define TOK_OR 2
#define TOK_AND 3
#define TOK_NOT 4
#define TOK_EQ 5
#define TOK_NE 6
#define TOK_LT 7
#define TOK_LE 8
#define TOK_GT 9
#define TOK_GE 10
#define TOK_PIPE 11
#define TOK_ADD 12
#define TOK_SUB 13
#define TOK_MUL 14
#define TOK_DIV 15
#define TOK_REM 16
#define TOK_USING 17
#define TOK_TEXT 18
#define TOK_MONEY 19
#define TOK_INT 20
#define TOK_STRING 21
#define TOK_RAW 22
#define TOK_DOWNSHIFT 23
#define TOK_PRETTY 24
#define TOK_UPSHIFT 25
#define TOK_BOOL 26
#define TOK_DATE 27
#define TOK_FALSE 28
#define TOK_TRUE 29
#define TOK_MONEYCONST 30
#define TOK_COMMA 31
#define TOK_COLON 32
#define TOK_SEMI 33
#define TOK_LC 34
#define TOK_RC 35
#define TOK_LP 36
#define TOK_RP 37
#define TOK_LB 38
#define TOK_RB 39
#define TOK_ARRAY 40
#define TOK_MAX 41
#define TOK_MIN 42
#define TOK_LENGTH 43
#define TOK_SUM 44
#define TOK_AVG 45
#define TOK_POP 46
#define TOK_POPALL 47
#define TOK_IF 48
#define TOK_WHILE 49
#define TOK_ELSE 50
#define TOK_LOOPARRAY 51
#define TOK_CONT 52
#define TOK_BREAK 53
#define TOK_DOMAIN 54
#define TOK_ECHO 55
#define TOK_DECLARE 56
#define TOK_ASK 57
#define TOK_NEXTASK 58
#define TOK_CALL 59
#define TOK_FUNCTION 60
#define TOK_RETURNING 61
#define TOK_RETURN 62
#define TOK_EXPLAIN 63
#define TOK_QUESTION 64

#define GRAM_eof 0
#define GRAM_error 1
#define GRAM_NUMBER 2
#define GRAM_STRING 3
#define GRAM_NUMBER_HUGE 4
#define GRAM_WORD 5
#define GRAM_ASG 6
#define GRAM_OR 7
#define GRAM_AND 8
#define GRAM_NOT 9
#define GRAM_RELOP 10
#define GRAM_PIPE 11
#define GRAM_ADDOP 12
#define GRAM_MULOP 13
#define GRAM_USING 14
#define GRAM_TEXT 15
#define GRAM_TYPE 16
#define GRAM_STRINGMOD 17
#define GRAM_BOOLCONST 18
#define GRAM_MONEYCONST 19
#define GRAM_COMMA 20
#define GRAM_COLON 21
#define GRAM_SEMI 22
#define GRAM_LC 23
#define GRAM_RC 24
#define GRAM_LP 25
#define GRAM_RP 26
#define GRAM_LB 27
#define GRAM_RB 28
#define GRAM_ARRAY 29
#define GRAM_AGGR 30
#define GRAM_POP 31
#define GRAM_COND 32
#define GRAM_ELSE 33
#define GRAM_LOOPARRAY 34
#define GRAM_CONT 35
#define GRAM_DOMAIN 36
#define GRAM_ECHO 37
#define GRAM_DECLARE 38
#define GRAM_ASK 39
#define GRAM_NEXTASK 40
#define GRAM_CALL 41
#define GRAM_FUNCTION 42
#define GRAM_RETURNING 43
#define GRAM_RETURN 44
#define GRAM_EXPLAIN 45
#define GRAM_QUESTION 46

typedef  union {
long l;
char *s;
short n;
int i;
str_code sc;
struct { short val, extend; } tok; /* for simple tokens */
struct domain *domain;
struct block *block;
struct expstr  expstr;
} ZC_gramunion;
extern ZC_gramunion ZC_inp_parseval;

extern short ZC_lineno, ZC_pos;
extern int ZC_lastchar, scanner_base;
extern char *ZC_filename, ZC_eof_not_allowed;
extern FILE *ZC_file;

extern int ZC_curr_token;
extern simple_stmt();
extern endargs();
extern struct block * make_vtype();
extern struct block * make_vtype();
extern struct block * make_vtype();
extern struct block * make_vtype();
extern struct block * make_vtype();
extern struct block * make_vtype();
extern struct domain * setdom_mm();
extern struct domain * setdom_mm();
extern struct expstr   mkarlist();
extern struct expstr   mkarlist();
extern pusharg();
extern pusharg();
extern int cond_reserve_block();
extern int start_looparray();
extern callfunc();
extern str_code frameset();
extern setdom();
extern add_varblock();
extern add_varblock();
extern add_varblock();
extern add_varasg();
extern varassign();
extern simple_stmt();
extern simple_stmt();
extern endargs();
extern endargs();
extern simple_stmt();
extern simple_stmt();
extern echo_text();
extern echo_text();
extern add_condition();
extern add_condition();
extern add_condition();
extern struct block * make_vtype();
extern struct block * make_vtype();
extern struct block * make_vtype();
extern struct block * make_vtype();
extern struct expstr   buildexp();
extern struct expstr   buildexp();
extern struct expstr   monoexp();
extern struct expstr   buildexp();
extern struct expstr   buildexp();
extern struct expstr   buildexp();
extern struct expstr   buildexp();
extern struct expstr   monoexp();
extern struct expstr   usingexp();
extern struct expstr   builtin();
extern struct expstr   wordexp();
extern struct expstr   numexp();
extern struct expstr   numexp();
extern struct expstr   shortnumexp();
extern struct expstr   scnumexp();
